/**
 * @Author Bharath A Reddy
 */
import java.net.*;
import java.io.*;

public class SMTPSender
{
     private String error = "";
     private String host = "206.235.24.252";
     private final int port = 25;
     private Socket sock;

     public SMTPSender(){
     }
     public SMTPSender(String host){
          try{
               this.host = host;
               sock = new Socket( this.host , port );
               DataInputStream dis = new DataInputStream( sock.getInputStream() );
               PrintStream ps = new PrintStream( sock.getOutputStream() );
			   System.out.println("Connected.......");
               error = dis.readLine();
               ps.println("HELO "+this.host);
               String temp = dis.readLine();
               if( !temp.startsWith("250") )
               {
                error = error + temp;
               }
			   System.out.println("Yes......."+error);
  			   System.out.println("Yes.......temp"+temp);
          }catch(Exception ex)
          {
               System.out.println(ex.getMessage());
          }
	 }
     public boolean reConnect(){
          try{
               if( checkConnection() )
               {
                    sock = new Socket( host , port );
        			DataInputStream dis = new DataInputStream( sock.getInputStream() );
				    PrintStream ps = new PrintStream( sock.getOutputStream() );
					error = dis.readLine();
				    ps.println("HELO "+host);
				    String temp = dis.readLine();
				    if( !temp.startsWith("250") )
				    {
					  error = error + temp;
				    }
               }
               return true;
          }catch(Exception ex)
          {
               System.out.println(ex.getMessage());
          }
          return false;
     }
     public boolean checkConnection()
     {
          try{
               DataInputStream dis = new DataInputStream( sock.getInputStream() );
               PrintStream ps = new PrintStream( sock.getOutputStream() );
               ps.println("noop");
               String st = dis.readLine();
               if( st.startsWith("250") )
               {
                    return true;
               }
          }catch(Exception ex)
          {
               System.out.println(ex.getMessage());
          }
          return false;
     }
     public void closeConnection()
     {
          try{
               DataInputStream dis = new DataInputStream( sock.getInputStream() );
               PrintStream ps = new PrintStream( sock.getOutputStream() );
               ps.println("quit");
               String st = dis.readLine();
			   sock.close();
          }catch(Exception ex)
          {
               System.out.println(ex.getMessage());
          }
     }
     public void sendMail(
                              String from,
                              String to,
                              String subject,
                              String message
                          )
     throws SocketException,IOException{
          try{
               DataInputStream dis = new DataInputStream( sock.getInputStream() );
               PrintStream ps = new PrintStream( sock.getOutputStream() );

  			   String temp = "";

               ps.println("MAIL FROM:<"+from+">");
               temp = dis.readLine();

               if( !temp.startsWith("250") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }
               ps.println("RCPT TO:<"+to+">");
               temp = dis.readLine();
               if( !temp.startsWith("250") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }
               ps.println("DATA");
               temp = dis.readLine();
               if( !temp.startsWith("354") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }

               ps.println("Message-ID:<"+System.currentTimeMillis()+from.substring(from.indexOf('@'))+">");
               ps.println("Date:"+(new java.util.Date()).toString());
               ps.println("From:<"+from+">");
               ps.println("To:<"+to+">");
               ps.println("Subject:"+subject);
               ps.println("X-Mailer: MailerX\r\n");
               ps.println(message+"\n\r");
               ps.println("");
               ps.println(".");
               temp = dis.readLine();
               if( !temp.startsWith("354") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }
               System.out.println("Mail Successfully send To :"+to);
          }catch(NullPointerException ex)
          {
               System.out.println(ex.getMessage());
          }
     }
     public void sendCCMail(
                              String from,
                              String to[],
                              String subject,
                              String message
                          )
     throws SocketException,IOException{
          try{
               DataInputStream dis = new DataInputStream( sock.getInputStream() );
               PrintStream ps = new PrintStream( sock.getOutputStream() );

               String temp = "";

               ps.println("MAIL FROM:<"+from+">");
               temp = dis.readLine();
               if( !temp.startsWith("250") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }

			   if( to != null )
			   {
				   for(int i=0;i<to.length;i++)
				   {
					   ps.println("RCPT TO:<"+to[i]+">");
					   temp = dis.readLine();
					   if( !temp.startsWith("250") )
					   {
							error = error + temp;
							System.out.println(error);
							//return;
					   }
				   }
			   }

               ps.println("DATA");
               temp = dis.readLine();
               if( !temp.startsWith("354") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }

               ps.println("Message-ID:<"+System.currentTimeMillis()+from.substring(from.indexOf('@'))+">");
               ps.println("Date:"+(new java.util.Date()).toString());
               ps.println("From:<"+from+">");
			   String go = "";
			   if( to != null )
			   {
					for( int i=0;i<to.length;i++)
					{
							go = go + to[i] + ",";
					}
					go = go.substring(0,go.length()-1);
			   }
			   ps.println("To:<"+go+">");
               ps.println("Subject:"+subject);
               ps.println("X-Mailer: MailerX\r\n");
               ps.println(message+"\n\r");
               ps.println("");
               ps.println(".");
               temp = dis.readLine();
               if( !temp.startsWith("354") )
               {
                error = error + temp;
				System.out.println(error);
				//return;
               }
               System.out.println("Mail Successfully send To :"+to);
          }catch(NullPointerException ex)
          {
               System.out.println(ex.getMessage());
          }
     }
	 public String getError()
	 {
	 	return error;
	 }
	 public void clearError()
	 {
	 	error = "";
	 }
}